﻿// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_H_
#define _OVRMIRROR_H_

#include <stdint.h> // C99

#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32
    
#ifdef OVRMIRROR_EXPORTS
#define	OVRMIRROR_DLL_EXTERN __declspec(dllexport)
#else
#define	OVRMIRROR_DLL_EXTERN __declspec(dllimport)
#endif
    
#else

#define OVRMIRROR_DLL_EXTERN /* Nothing. */
    
#endif

OVRMIRROR_DLL_EXTERN void UnitySetGraphicsDevice( void* device, int32_t deviceType, int32_t eventType );
OVRMIRROR_DLL_EXTERN void UnityRenderEvent( int32_t eventID );

OVRMIRROR_DLL_EXTERN void OVRMirrorCreate();
OVRMIRROR_DLL_EXTERN void OVRMirrorDestroy();
OVRMIRROR_DLL_EXTERN void OVRMirrorSetWindowFlags( int32_t windowFlags );
OVRMIRROR_DLL_EXTERN void OVRMirrorOpenWindow();
OVRMIRROR_DLL_EXTERN void OVRMirrorCloseWindow();
OVRMIRROR_DLL_EXTERN int32_t OVRMirrorGetWindowState();
OVRMIRROR_DLL_EXTERN uint64_t OVRMirrorGetClientSize();
OVRMIRROR_DLL_EXTERN int32_t OVRMirrorSetRenderTexture( void* nativeTex );
OVRMIRROR_DLL_EXTERN void OVRMirrorSetViewportRect( float x, float y, float w, float h );
OVRMIRROR_DLL_EXTERN void OVRMirrorSetRenderEventID( int32_t eventID );
OVRMIRROR_DLL_EXTERN void OVRMirrorResetRenderEventID();

#undef OVRMIRROR_DLL_EXTERN

#ifdef __cplusplus
}
#endif

#endif // _OVRMIRROR_H_
