// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_COMMON_CONFIG_HPP_
#define _OVRMIRROR_COMMON_CONFIG_HPP_

#ifdef _WIN32
#include <Windows.h>
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include <stdint.h> // C99

#ifdef _WIN32
#include <gl/GL.h>
#else // Mac
#include <OpenGL/OpenGL.h>
#endif

// Graphics device identifiers in Unity
enum GfxDeviceRenderer
{
	kGfxRendererOpenGL = 0,          // OpenGL
	kGfxRendererD3D9,                // Direct3D 9
	kGfxRendererD3D11,               // Direct3D 11
	kGfxRendererGCM,                 // Sony PlayStation 3 GCM
	kGfxRendererNull,                // "null" device (used in batch mode)
	kGfxRendererHollywood,           // Nintendo Wii
	kGfxRendererXenon,               // Xbox 360
	kGfxRendererOpenGLES,            // OpenGL ES 1.1
	kGfxRendererOpenGLES20Mobile,    // OpenGL ES 2.0 mobile variant
	kGfxRendererMolehill,            // Flash 11 Stage3D
	kGfxRendererOpenGLES20Desktop,   // OpenGL ES 2.0 desktop variant (i.e. NaCl)
	kGfxRendererCount
};

// Event types for UnitySetGraphicsDevice
enum GfxDeviceEventType
{
	kGfxDeviceEventInitialize = 0,
	kGfxDeviceEventShutdown,
	kGfxDeviceEventBeforeReset,
	kGfxDeviceEventAfterReset,
};

namespace OVRMirror
{

struct FRECT32
{
	float x, y, w, h;
};

struct ISIZE32
{
	int32_t w, h;
};

struct MyVertex {
	float x, y, z;
	uint32_t color;
	float u, v;
};

#ifdef _WIN32
// COM-like Release macro
#ifndef SAFE_RELEASE
#define SAFE_RELEASE( a ) if( a != NULL ) { a->Release(); a = NULL; }
#endif
#endif

} // namespace OVRMirror

#endif // _OVRMIRROR_COMMON_CONFIG_HPP_
