// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_COMMON_THREAD_HPP_
#define _OVRMIRROR_COMMON_THREAD_HPP_

#include "Config.hpp"

#ifdef _WIN32
#include <boost/thread.hpp>
#endif // _WIN32
#ifdef __APPLE__
#include <thread>
#include <mutex>
#include <boost/bind.hpp>
#include <unistd.h>
#endif// __APPLE__

namespace OVRMirror
{

#ifdef _WIN32
typedef boost::mutex								Mutex;
typedef boost::lock_guard<boost::mutex>				LockGuardMutex;
typedef boost::unique_lock<boost::mutex>			UniqueLockMutex;
typedef boost::recursive_mutex						RecursiveMutex;
typedef boost::lock_guard<boost::recursive_mutex>	LockGuardRecursiveMutex;
typedef boost::unique_lock<boost::recursive_mutex>	UniqueLockRecursiveMutex;
typedef boost::condition_variable					ConditionVariable;
#else
typedef std::mutex									Mutex;
typedef std::lock_guard<std::mutex>					LockGuardMutex;
typedef std::unique_lock<std::mutex>				UniqueLockMutex;
typedef std::recursive_mutex						RecursiveMutex;
typedef std::lock_guard<std::recursive_mutex>		LockGuardRecursiveMutex;
typedef std::unique_lock<std::recursive_mutex>		UniqueLockRecursiveMutex;
typedef std::condition_variable						ConditionVariable;
#endif

} // namespace OVRMirror

#endif // _OVRMIRROR_COMMON_THREAD_HPP_
