// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_WINDOWS_DX9RENDERER_HPP_
#define _OVRMIRROR_WINDOWS_DX9RENDERER_HPP_

#include "../../Common/IRenderer.hpp"
#include "../../Common/Primitive.hpp"

#include <d3d9.h>

namespace OVRMirror
{
namespace Windows
{

class DX9Renderer : public IRenderer
{
	RecursiveMutex				_mutex;

	bool						_isDeviceInitialized;
	ISIZE32						_backBufferSize;

	IDirect3DBaseTexture9*		_renderTexture; // memo: Require _mutex.lock()

	IDirect3DSwapChain9*		_swapChain;
	IDirect3DSurface9*			_backBuffer;
	IDirect3DVertexBuffer9*		_vertexBuffer;

	RenderTexturePrimitiveCache	_primitiveCache;

public:
	DX9Renderer();
	~DX9Renderer();

	virtual void SetRenderTextureImmediately( void* renderTexture );
	virtual void SetGraphicsDevice( void* device, int32_t eventType );
	virtual void Render( const RendererParams& rendererParams );

private:
	bool _PrepareDevice( const RendererParams& rendererParams );
	void _ShutdownDevice();
};

} // namespace Windows
} // namespace OVRMirror

#endif // _OVRMIRROR_WINDOWS_DX9RENDERER_HPP_
