// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_WINDOWS_OGLRENDERER_HPP_
#define _OVRMIRROR_WINDOWS_OGLRENDERER_HPP_

#include "../../Common/IRenderer.hpp"
#include "../../Common/Primitive.hpp"

namespace OVRMirror
{
namespace Windows
{

class OGLRenderer : public IRenderer
{
	RecursiveMutex				_mutex;

	bool						_isDeviceInitialized;
	HWND						_hWnd;
	HDC							_hDC;

	GLuint						_renderTexture; // memo: Require _mutex.lock()

	GLuint						_buffer;
	RenderTexturePrimitiveCache	_primitiveCache;

	PROC						_glActiveTexture;
	PROC						_glClientActiveTexture;
	PROC						_glGenBuffers;
	PROC						_glDeleteBuffers;
	PROC						_glBindBuffer;
	PROC						_glBufferData;
	PROC						_glBufferSubData;

public:
	OGLRenderer();
	~OGLRenderer();

	virtual void SetRenderTextureImmediately( void* renderTexture );
	virtual void SetGraphicsDevice( void* device, int32_t eventType );
	virtual void Render( const RendererParams& rendererParams );

private:
	bool _PrepareDevice( const RendererParams& rendererParams );
	void _ShutdownDevice();
};

} // namespace Windows
} // namespace OVRMirror

#endif // _OVRMIRROR_WINDOWS_OGLRENDERER_HPP_
