// Copyright (c) 2014 Nora
// Released under the MIT license
// http://opensource.org/licenses/mit-license.php
#ifndef _OVRMIRROR_WINDOWS_TASKTRAY_HPP_
#define _OVRMIRROR_WINDOWS_TASKTRAY_HPP_

#include "../Common/Config.hpp"
#include "../Common/Thread.hpp"

namespace OVRMirror
{
namespace Windows
{

class Tasktray
{
public:
	static void _CreateWindow();
	static void _DestroyWindow();

private:
	static void _RegisterClass();
	static void _InitializeNotifyIcon( HWND hWnd );
	static void _FinalizeNotifyIcon( HWND hWnd );
	static HMENU _InitializeMenu();
	static void _FinalizeMenu( HMENU hPopupMenu );
	static void _ShowTasktrayPopup( HMENU hPopupMenu, HWND hWnd );

	static LRESULT CALLBACK _WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
};

} // namespace Windows
} // namespace OVRMirror

#endif // _OVRMIRROR_WINDOWS_TASKTRAY_HPP_
